%{
/*
 * The Termprocessor Kimwitu
 *
 * Copyright (c) 1991 University of Twente, Dept TIOS.
 * All rights reserved.
 *
 */
%}
%{
/*
 * kimwy.y
 */
#if ! (defined(lint) || defined(SABER) || defined(CODECENTER))
static char kimwy_yAccesSid[] = "@(#)$Id: kimwy.y,v 2.30 1996/05/23 15:23:31 belinfan Rel $";
#endif
%}

%{
/***************************************************************************/
/*
 * Name conventions: tokens are in CAPITALS
 * nonterminals are in lowercase
 * operators are capitalized
 *
 */
%}
%{
#include "k.h"
#include "parse.h"
#include "extocc.h"
#include "defocc.h"
#include "util.h" /* for the v_add_to routines */


static ID pl_phylum;						/* local kimwy.y var */
static ID pl_withvariable;					/* local kimwy.y var */
static filelinestack pl_filelinestack;				/* local kimwy.y var */
static nooperatorsstack pl_nooperatorsstack;			/* local kimwy.y var */
static int non_default_outmostpattern = 0;			/* local kimwy.y var */

#define dollar_mark_set() (pl_withvariable != 0)
#define do_MainC() do { if ( dollar_mark_set() ) do_NORMAL(); else do_C(); } while(kc_zero_constant)
extern void do_NORMAL();
extern void do_CEXPR();
extern void do_CEXPRDQ();
extern void do_CEXPRSQ();
extern void do_C();
extern void yyerror();


#define pf_setfileline(x) do { (x)->file = pg_filename; \
			       (x)->line = pg_lineno; \
			     } while(kc_zero_constant)
#define pf_pushfileline() pl_filelinestack = Consfilelinestack( FileLine( pg_filename, pg_lineno ), pl_filelinestack )
#define pf_setstacktopfileline(x) do { (x)->file = pl_filelinestack->u.Consfilelinestack.fileline_1->u.FileLine.casestring_1; \
				       (x)->line = pl_filelinestack->u.Consfilelinestack.fileline_1->u.FileLine.int_1; \
				     } while(kc_zero_constant)
#define pf_topfileline() (pl_filelinestack->u.Consfilelinestack.fileline_1)
#define pf_popfileline() do { filelinestack tmp_pl_filelinestack = pl_filelinestack; \
		              pl_filelinestack = pl_filelinestack->u.Consfilelinestack.filelinestack_1; \
		              free_fileline( tmp_pl_filelinestack->u.Consfilelinestack.fileline_1, True ); \
			      free_filelinestack( tmp_pl_filelinestack, False ); \
			    } while(kc_zero_constant)
#define pf_setwithvariable(x) pl_withvariable = (x)
#define pf_resetwithvariable() pl_withvariable = 0
#define pf_push_no_operators() pl_nooperatorsstack = Consnooperatorsstack( non_default_outmostpattern, pl_nooperatorsstack );
#define pf_pop_no_operators() do { nooperatorsstack tmp_pl_nooperatorsstack = pl_nooperatorsstack; \
				   non_default_outmostpattern = pl_nooperatorsstack->u.Consnooperatorsstack.int_1; \
		                   pl_nooperatorsstack = pl_nooperatorsstack->u.Consnooperatorsstack.nooperatorsstack_1; \
			           free_nooperatorsstack( tmp_pl_nooperatorsstack, False ); \
			         } while(kc_zero_constant)

%}

%token <yt_casestring> T_ID
%token <yt_int> T_INT
%token <yt_int> T_CNEWLINES
%token <yt_casestring> T_CLINE
%token <yt_casestring> T_CEXPRESSION
%token <yt_int> T_DOLLARVAR
%token <yt_casestring> T_INCLUDE
%token <yt_casestring> T_INCLUDESTART
%token T_INCLUDEEND
%token T_LIST
%token T_ARROW
%token T_STATIC
%token T_WITH
%token T_FOREACH
%token T_DEFAULT
%token T_UNPBLOCKSTART
%token T_UNPBLOCKEND
%token T_PERCENTVIEW
%token T_PERCENTSTORAGECLASS

%type <yt_INT>			dollarvar
%type <yt_ID>			id
%type <yt_INT>			int
/* %type <yt_STRING>		string */
/* no %type for			specification */
/* no %type for			declarations */
/* no %type for			declaration */
%type <yt_phylumdeclaration>	phylumdeclaration
%type <yt_storageoption>	storageoption
%type <yt_productionblock>	productionblock
%type <yt_alternatives>		alternatives
%type <yt_alternative>		alternative
%type <yt_arguments>		arguments
%type <yt_Ccode_option>		Ccode_option
%type <yt_attributes>		attributes_option
%type <yt_attribute>		attribute
%type <yt_attribute_initialisation_option>	attribute_init_option
%type <yt_Cexpression>		Cexpression
%type <yt_Cexpression_elem>	Cexpression_elem
%type <yt_CexpressionDQ>	CexpressionDQ
%type <yt_CexpressionDQ_elem>	CexpressionDQ_elem
%type <yt_CexpressionSQ>	CexpressionSQ
%type <yt_CexpressionSQ_elem>	CexpressionSQ_elem
%type <yt_Ctext>		MainCbody
%type <yt_Ctext>		MainCBodycontinuation
%type <yt_Ctext>		Cbody
%type <yt_Ctext>		Ctext
%type <yt_Ctext_elem>		Ctext_elem
%type <yt_Ctext_elem>		foreach_continuation
%type <yt_Ctexts>		init_option
%type <yt_includedeclaration>	includedeclaration
%type <yt_includefiles>		includefiles_option
%type <yt_includefiles>		includefiles
%type <yt_includes>		includes
%type <yt_include>		include
%type <yt_rwdeclaration>	rwdeclaration
%type <yt_outmostpatterns>	outmostpatterns
%type <yt_outmostpattern>	outmostpattern
%type <yt_pattern>		pattern
%type <yt_patterns>		patternsoption
%type <yt_patterns>		patterns
%type <yt_term>			term
%type <yt_terms>		termsoption
%type <yt_terms>		terms
%type <yt_fndeclaration>	functiondeclaration
%type <yt_fnarguments>		fnargumentsoption
%type <yt_fnarguments>		fnarguments
%type <yt_ID>			fnargument
%type <yt_Cvariabledeclarations>	fnargdecls_option
%type <yt_Cvariabledeclaration>	fnargdecl
%type <yt_Cvariables>		fnargvars
%type <yt_Cvariable>		fnargvar
%type <yt_int>			starseqoption
%type <yt_withcases>		withcases
%type <yt_withcase>		withcase
%type <yt_unparsedeclaration>	unparsedeclaration
%type <yt_unparseclauses>	unparseclauses
%type <yt_unparseclause>	unparseclause
%type <yt_viewnames>		defviewnames
%type <yt_viewnames>		useviewnames
%type <yt_unparseitems>		unparseitems
%type <yt_unparseitem>		unparseitem
%type <yt_unpsubterm>		unpsubterm
%type <yt_unpattributes>	unpattributes
%type <yt_ID>			unpattribute
%type <yt_viewnameoption>	viewnameoption
%type <yt_viewnames>		viewdeclaration
%type <yt_storageclasses>	storageclassdeclaration
%type <yt_storageclasses>	defstorageclasses


%start specification


%%

dollarvar
:	T_DOLLARVAR
		{ $$ = Int( $1 ); pf_setfileline( $$ ); }
;

id
:	T_ID
		{ $$ = Id( Str( $1 )); pf_setfileline( $$ ); }
;

int
:	T_INT
		{ $$ = Int( $1 ); pf_setfileline( $$ ); }
;

/*
string
:	STRING
		{ $$ = String( $1 ); pf_setfileline( $$ ); }
;
 */

specification
:		{ /* initialize variables and scanner state */
		  pl_filelinestack = Nilfilelinestack();
		  pl_nooperatorsstack = Nilnooperatorsstack();
		  pl_phylum = 0;
		  pl_withvariable = 0;
									  do_NORMAL();
		}
	declarations
;

declarations
:	declaration
|	declarations declaration
;

declaration
:	phylumdeclaration
		{ Thephylumdeclarations = mergephylumdeclarations( $1, Thephylumdeclarations ); }
|	rwdeclaration
		{ Therwdeclarations = Consrwdeclarations( $1, Therwdeclarations ); }
|	functiondeclaration
		{ Thefndeclarations = Consfndeclarations( $1, Thefndeclarations ); }
|	includedeclaration
		{ }
|	unparsedeclaration
		{ Theunparsedeclarations = Consunparsedeclarations( $1, Theunparsedeclarations ); }
|	viewdeclaration
		{ }
|	storageclassdeclaration
		{ }
;

phylumdeclaration
:	id storageoption ':'
		{ pl_phylum = $1; }
			      productionblock Ccode_option ';'
		{ $$ = PhylumDeclaration( $1, $2, $5, $6 ); v_extendoccur( pl_phylum, ITUserPhylum( $$ ) ); }
;

storageoption
:	/* empty */
		{ $$ = NoStorageOption(); }
|	'{' id '}'
		{ $$ = PositiveStorageOption( $2 ); v_extendoccur( $2, ITStorageClass() ); }
|	'{' '!' id '}'
		{ $$ = NegativeStorageOption( $3 ); v_extendoccur( $3, ITStorageClass() ); }
;

productionblock
:	/* empty */
		{ $$ = Emptyproductionblock(); }
|	T_LIST id
		{ $$ = ListAlternatives( makeListAlternatives( pl_phylum, $2 ), $2 );
		  Theargsnumbers = insert_in_argsnumbers(0, Theargsnumbers);
		  Theargsnumbers = insert_in_argsnumbers(2, Theargsnumbers);
		}
|	alternatives
		{ $$ = NonlistAlternatives( $1 ); }
;

alternatives
:	alternative
		{ $$ = Consalternatives( $1, Nilalternatives() ); }
|	alternatives '|' alternative
		{ $$ = Consalternatives( $3, $1 ); }
;

alternative
:	id '(' { pg_no_of_arguments = 0; } arguments { Theargsnumbers = insert_in_argsnumbers(pg_no_of_arguments, Theargsnumbers); } ')'
		{ $$ = Alternative( $1, $4 );
		  v_extendoccur( $1, ITUserOperator( $$, pl_phylum ) ); }
;

arguments
:	/* empty */
		{ $$ = Nilarguments(); }
|	arguments id
		{ $$ = Consarguments( $2, $1 ); pg_no_of_arguments++; }
;

Ccode_option
:	/* empty */
		{ $$ = CcodeOption( Nilattributes(), NilCtexts() ); }
|	'{' attributes_option init_option '}'
		{ $$ = CcodeOption( $2, $3 ); }
;

attributes_option
:	/* empty */
		{ $$ = Nilattributes(); }
|	attributes_option attribute
		{ $$ = Consattributes( $2, $1 ); }
;

attribute
:	id id attribute_init_option ';'
		{ $$ = Attribute( $1, $2, $3 ); }
;

attribute_init_option
:	/* empty */
		{ $$ = Noattribute_initialisation(); }
|	'='
									{ do_CEXPR(); }
	     Cexpression
									{ do_NORMAL();
		  $$ = Yesattribute_initialisation( $3 ); }
;

/*
 * we use the fact that the empty list is the first 'element' that is
 * parsed into the list
 */
Cexpression
: 	/* empty */
		{ $$ = NilCexpression(); pf_setfileline( $$ ); }
|	Cexpression Cexpression_elem
		{ $$ = ConsCexpression( $2, $1 ); $$->file = $1->file; $$->line = $1->line; }
;

Cexpression_elem
:	T_CEXPRESSION
		{ $$ = CExpressionPart( $1 ); }
|	dollarvar
		{ $$ = CExpressionDollarvar( $1 ); }
|	'\n'
		{ $$ = CExpressionNl( 1 ); }
|	T_CNEWLINES
		{ $$ = CExpressionNl( $1 ); }
|	'\"' CexpressionDQ '\"'
		{ $$ = CExpressionDQ( $2 ); }
|	'\'' CexpressionSQ '\''
		{ $$ = CExpressionSQ( $2 ); }
|	'(' Cexpression ')'
		{ $$ = CExpressionPack( $2 ); }
;

CexpressionDQ
:	/* empty */
		{ $$ = NilCexpressionDQ(); }
|	CexpressionDQ CexpressionDQ_elem
		{ $$ = ConsCexpressionDQ( $2, $1 ); }
;

CexpressionDQ_elem
:	T_CEXPRESSION
		{ $$ = CExpressionDQPart( $1 ); }
|	'\n'
		{ $$ = CExpressionDQNl( 1 ); }
;

CexpressionSQ
:	/* empty */
		{ $$ = NilCexpressionSQ(); }
|	CexpressionSQ CexpressionSQ_elem
		{ $$ = ConsCexpressionSQ( $2, $1 ); }
;

CexpressionSQ_elem
:	T_CEXPRESSION
		{ $$ = CExpressionSQPart( $1 ); }
|	'\n'
		{ $$ = CExpressionSQNl( 1 ); }
;

/*
 * use global variable to pass/save the $fnargument that can be picked up
 * and inserted in the withcases in the MainCbody continuation so that
 * it can return a complete CtextWithexpression
 */
MainCbody
:	'{'
									{ do_MainC(); pf_pushfileline(); }
	    MainCBodycontinuation
									{ do_NORMAL(); }
		  '}'
		{ $$ = $3; pf_setstacktopfileline( $$ ); pf_popfileline(); }
;

MainCBodycontinuation
:	Ctext
		{ $$ = $1; pf_setstacktopfileline( $$ ); }
|	withcases
		{ Ctext_elem tmp = CTextWithexpression( WEVariable( pl_withvariable ), $1 );
		  pf_setstacktopfileline( tmp );
		  $$ = ConsCtext( tmp, NilCtext() );
		  pf_setstacktopfileline( $$ ); 
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; }
;

Cbody
:	'{'
									{ do_C(); pf_pushfileline(); pf_push_no_operators(); }
	    Ctext
									{ do_NORMAL(); }
		 '}'
		{ $$ = $3; pf_setstacktopfileline( $$ ); pf_popfileline(); pf_pop_no_operators(); }
;

Ctext
:	/* empty */
		{ $$ = NilCtext(); pf_setfileline( $$ ); }
|	Ctext
		{ pf_pushfileline(); }
	Ctext_elem
		{ $$ = ConsCtext( $3, $1 ); pf_setstacktopfileline( $3 ); pf_popfileline(); $$->file = $1->file; $$->line = $1->line; }
;

Ctext_elem
:	T_CLINE
		{ $$ = CTextLine( $1 ); }
|	dollarvar
		{ $$ = CTextDollarVar( $1 ); }
|	'\n'
		{ $$ = CTextNl( 1 ); }
|	T_CNEWLINES
		{ $$ = CTextNl( $1 ); }
|	'\"'
									{ do_CEXPRDQ(); }
	     CexpressionDQ '\"'
									{ do_C();
		  $$ = CTextCexpressionDQ( $3 ); }
|	'\''
									{ do_CEXPRSQ(); }
	     CexpressionSQ '\''
									{ do_C();
		  $$ = CTextCexpressionSQ( $3 ); }
/* |	'('  Cexpression   ')' */
|	Cbody
									{ do_C();
		  $$ = CTextCbody( $1 ); }
|	T_FOREACH 
									{ do_NORMAL(); }
		foreach_continuation
									{ do_C();
		  $$ = $3; }
|	T_WITH
									{ do_NORMAL(); }
	        '('
									{ do_CEXPR(); }
						Cexpression
									{ do_NORMAL(); }
							    ')' '{' withcases '}'
									{ do_C();
		  $$ = CTextWithexpression( WECexpression( $5 ), $9 );
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; }
;

foreach_continuation
:		'(' '$' id              ';' id
									{ do_CEXPR(); }
						Cexpression
									{ do_NORMAL(); }
							    ')' '{' withcases '}'
		{ $$ = CTextForeachwithcases( $5, $7, WEVariable( $3 ), $11 );
		  if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; }
|		'(' outmostpattern ';' { non_default_outmostpattern = 0; } id
									{ do_CEXPR(); }
						Cexpression
									{ do_NORMAL(); }
							    ')' Cbody
		{ if ( $2 && $2->prod_sel == sel_OPOperatorWildcard) {
			$$ = CTextForeachexpression( $5, $7, $2->u.OPOperatorWildcard.ID_1, $10 );
		  } else {
			$$ = CTextForeachpattern( $5, $7, Withcase( Consoutmostpatterns( $2, Niloutmostpatterns() ), $10 ) );
		  }
		}
;

init_option
:	/* empty */
		{ $$ = NilCtexts(); }
|	Cbody
		{ $$ = ConsCtexts( $1, NilCtexts() ); }
;

includedeclaration
:	T_INCLUDESTART includefiles_option { pf_pushfileline(); } includes T_INCLUDEEND
		{{includedeclaration pl_includedeclaration  = IncludeDeclaration( $4 );
		  set_includefiles( $2, pl_includedeclaration );
		  pf_setstacktopfileline( pl_includedeclaration );
		  pf_popfileline();
		}}
;

includefiles_option
:	/* empty */
		{{ includefile pl_includefile = IncludeFile( mkcasestring(INC_CODE) );
		  $$ = Consincludefiles( pl_includefile, Nilincludefiles() );
		}}
|	includefiles
		{ $$ = $1; }
;

includefiles
:	T_ID
		{{ includefile pl_includefile = IncludeFile( $1 );
		  if (pl_includefile->newinclude) {
			v_report(Warning( NoFileLine(), ProblemSC( "old include redirection keyword (please replace the `KIMW_' part by `KC_'):", $1 )));
			pl_includefile = pl_includefile->newinclude;
		  }
		  if ((pl_includefile->inc_type == include_file) || (pl_includefile->inc_type == include_header)) {
		        $$ = Consincludefiles( pl_includefile, Nilincludefiles() );
		  } else {
			v_report(NonFatal( NoFileLine(), ProblemSC( "unknown include redirection keyword:", $1 ))); 
		        $$ = Nilincludefiles();
		  }
		}}
|	includefiles T_ID
		{{ includefile pl_includefile = IncludeFile( $2 );
		  if (pl_includefile->newinclude) {
			v_report(Warning( NoFileLine(), ProblemSC( "old include redirection keyword (please replace the `KIMW_' part by `KC_'):", $2 )));
			pl_includefile = pl_includefile->newinclude;
		  }
		  if ((pl_includefile->inc_type == include_file) || (pl_includefile->inc_type == include_header)) {
		        $$ = Consincludefiles( pl_includefile, $1 );
		  } else {
			v_report(NonFatal( NoFileLine(), ProblemSC( "unknown include redirection keyword:", $2 ))); 
		        $$ = $1;
		  }
		}}
;

includes
:	/* empty */
		{ $$ = Nilincludes(); }
|	includes include
		{ $$ = Consincludes( $2, $1 ); }
;

include
:	T_INCLUDE
		{ $$ = Include( $1 ); }
|	'\n'
		{ $$ = IncludeNl( 1 ); }
;

rwdeclaration
:	outmostpatterns T_ARROW 
		{ if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; }
				term ';'
		{ $$ = RwDeclaration( $1, $4 ); }
;

outmostpatterns
:	outmostpattern
		{ $$ = Consoutmostpatterns( $1, Niloutmostpatterns() ); }
|	outmostpatterns ',' outmostpattern
		{ $$ = Consoutmostpatterns( $3, $1 ); }
;

outmostpattern
:	id				/* operator (wildcard for subterms) */
		{ $$ = OPOperatorWildcard( $1 ); non_default_outmostpattern = 1; }
|	id '(' patternsoption ')'	/* operator + subterms */
		{ $$ = OPOperator( $1, $3 ); non_default_outmostpattern = 1; }
|	id '=' outmostpattern			/* non-leaf variable */
		{ $$ = OPNonLeafVariable( $1, $3 ); non_default_outmostpattern = 1; }
|	'*'				/* wildcard */
		{ $$ = OPWildcard(); }
|	T_DEFAULT				/* wildcard */
		{ $$ = OPWildcard(); }
;

pattern
:	id				/* variable */
		{ $$ = PVariable( $1 ); }
|	id '(' patternsoption ')'	/* operator + subterms */
		{ $$ = POperator( $1, $3 ); }
|	'*'				/* wildcard */
		{ $$ = PWildcard(); }
|	T_DEFAULT				/* wildcard */
		{ $$ = PWildcard(); }
|	id '=' pattern			/* non-leaf variable */
		{ $$ = PNonLeafVariable( $1, $3 ); }
|	'\"'
									{ do_CEXPRDQ(); }
	    CexpressionDQ '\"'		/* string literal */
									{ do_NORMAL();
		  $$ = PStringLiteral( $3 ); }
|	int				/* int literal */
		{ $$ = PIntLiteral( $1 ); }
;

patternsoption
:	/* empty */
		{ $$ = Nilpatterns(); }
|	patterns
		{ $$ = $1; }
;

patterns
:	pattern
		{ $$ = Conspatterns( $1, Nilpatterns() ); }
|	patterns ',' pattern
		{ $$ = Conspatterns( $3, $1 ); }
;

term:	id				/* variable */
		{ $$ = TVariable( $1 ); }
|	id '(' termsoption ')'		/* operator + subterms */
		{ $$ = TOperator( $1, $3 ); }
|	'\"'
									{ do_CEXPRDQ(); }
	    CexpressionDQ '\"'		/* string literal */
									{ do_NORMAL();
		  $$ = TStringLiteral( $3 ); }
|	int				/* int literal */
		{ $$ = TIntLiteral( $1 ); }
;

termsoption
:	/* empty */
		{ $$ = Nilterms(); }
|	terms
		{ $$ = $1; }
;

terms
:	term
		{ $$ = Consterms( $1, Nilterms() ); }
|	terms ',' term
		{ $$ = Consterms( $3, $1 ); }
;

functiondeclaration
:	       id starseqoption id '(' fnargumentsoption ')' fnargdecls_option MainCbody
		{ $$ = FnDeclaration( $1, $2, $3, $5, $7, $8, GlobalFn() );
		  pf_resetwithvariable();
		  v_defoccur( $3, ITUserFunction( GlobalFn() ) ); }
|	T_STATIC id starseqoption id  '(' fnargumentsoption ')' fnargdecls_option MainCbody
		{ $$ = FnDeclaration( $2, $3, $4, $6, $8, $9, LocalFn( pg_filename ) );
		  pf_resetwithvariable();
		  v_defoccur( $4, ITUserFunction( LocalFn( pg_filename ) ) ); }
;

fnargumentsoption
:	/* empty */
		{ $$ = Nilfnarguments(); }
|	fnarguments
		{ $$ = $1; }
;

fnarguments
:	fnargument
		{ $$ = Consfnarguments( $1, Nilfnarguments() ); }
|	fnarguments ',' fnargument
		{ $$ = Consfnarguments( $3, $1 ); }
;

fnargument
:	id
		{ $$ = $1; }
|	'$' id
		{ $$ = $2; pf_setwithvariable( $2 ); }
;

fnargdecls_option
:	/*empty */
		{ $$ = NilCvariabledeclarations(); }
|	fnargdecls_option fnargdecl
		{ $$ = ConsCvariabledeclarations( $2, $1 ); }
;

fnargdecl
:	id fnargvars ';'
		{ $$ = CVariabledeclaration( $1, $2 ); }
;

fnargvars
:	fnargvar
		{ $$ = ConsCvariables( $1, NilCvariables() ); }
|	fnargvars ',' fnargvar
		{ $$ = ConsCvariables( $3, $1 ); }
;

fnargvar
:	starseqoption id						/* (ptr to) variable */
		{ $$ = CVPointer( $1, $2 ); }
|	starseqoption '('  starseqoption  id  ')'  '('  ')'		/* function */
		{ $$ = CVFunction( $1, $3, $4 ); }
;

starseqoption
:	/* empty */
		{ $$ = 0; }
|	starseqoption '*'
		{ $$ = $1 + 1; }
;

withcases
:	withcase
		{ $$ = Conswithcases( $1, Nilwithcases() ); }
|	withcases withcase
		{ $$ = Conswithcases( $2, $1 ); }
;

withcase
:	outmostpatterns ':' Cbody
		{ $$ = Withcase( $1, $3 ); }
;

unparsedeclaration
:	outmostpatterns T_ARROW
		{ if (! non_default_outmostpattern ) v_report(NonFatal( NoFileLine(), Problem1S( "can not infer type from `default' pattern(s)" )));
		  non_default_outmostpattern = 0; }
			      unparseclauses ';'
		{ $$ = UnparseDeclaration( $1, $4 ); }
;

unparseclauses
:	unparseclause
		{ $$ = Consunparseclauses( $1, Nilunparseclauses() ); }
|	unparseclauses unparseclause
		{ $$ = Consunparseclauses( $2, $1 ); }
;

unparseclause
:	'[' useviewnames  ':' unparseitems  ']'
	/* if no view was defined, we replace the implicit base_view
	 * (Nilviewnames) by an explicit one (ie. base_view)
	 */
		{ if (eq_viewnames( $2, Nilviewnames())) {
		      $$ = UnparseClause( Consviewnames( Id( Str( mkcasestring( "base_view" ))), $2 ), $4 );
		  } else {
		      $$ = UnparseClause( $2, $4 );
		} }
;

useviewnames
:	/* empty */
		{ $$ = Nilviewnames(); }
|     useviewnames id
		{ $$ = Consviewnames( $2, $1 ); }
;

unparseitems
:	/*empty*/
		{ $$ = Nilunparseitems(); }
|	unparseitems unparseitem
		{ $$ = Consunparseitems( $2, $1 ); }
;

unparseitem
:	'\"'
									{ do_CEXPRDQ(); }
	    CexpressionDQ '\"'		/* string literal */
									{ do_NORMAL(); }
	viewnameoption
		{ $$ = UnpStr( $3, $6 ); }
|	unpsubterm viewnameoption
		{ $$ = UnpSubexpr( $1, $2 ); }
|	Cbody
		{ $$ = UnpCtext( $1 ); }
|	T_UNPBLOCKSTART unparseitems T_UNPBLOCKEND
		{ $$ = UnpBody( $2 ); }
;

unpsubterm
:	id
		{ $$ = UnpSubTerm( $1 ); }
|	dollarvar
		{ $$ = UnpDollarvarTerm( $1 ); }
|	id unpattributes
		{ $$ = UnpSubAttr( $1, $2 ); }
|	dollarvar unpattributes
		{ $$ = UnpDollarvarAttr( $1, $2 ); }
|	'(' id ')' id
		{ $$ = UnpCastedVariable( $2, $4 ); }
;

unpattributes
:	unpattribute
		{ $$ = Consunpattributes( $1, Nilunpattributes() ); }
|	unpattributes unpattribute
		{ $$ = Consunpattributes( $2, $1 ); }
;

unpattribute
:	T_ARROW id
		{ $$ = $2; }
;

viewnameoption
:	/*empty*/
		{ $$ = NoViewname(); }
|	':' id
		{ $$ = YesViewname( $2 ); }
;

viewdeclaration
:	T_PERCENTVIEW defviewnames ';'
		{ $$ = $2; pg_viewshavebeendefined = True; }
;

defviewnames
:	id
		{ $$ = Consviewnames( $1, Nilviewnames());
		  v_add_to_viewnames( $1 );
		  v_extendoccur( $1, ITUserView() ); }
|	defviewnames id
		{ $$ = Consviewnames( $2, $1 );
		  v_add_to_viewnames( $2 );
		  v_extendoccur( $2, ITUserView() ); }
|	defviewnames ',' id
		{ $$ = Consviewnames( $3, $1 );
		  v_add_to_viewnames( $3 );
		  v_extendoccur( $3, ITUserView() ); }
;

storageclassdeclaration
:	T_PERCENTSTORAGECLASS defstorageclasses ';'
		{ $$ = $2; pg_storageclasseshavebeendefined = True; }
;

defstorageclasses
:	id
		{ $$ = Consstorageclasses( $1, Nilstorageclasses());
		  v_add_to_storageclasses( $1, f_emptyId() );
		  v_extendoccur( $1, ITStorageClass() ); }
|	defstorageclasses id
		{ $$ = Consstorageclasses( $2, $1 );
		  v_add_to_storageclasses( $2, f_emptyId() );
		  v_extendoccur( $2, ITStorageClass() ); }
|	defstorageclasses ',' id
		{ $$ = Consstorageclasses( $3, $1 );
		  v_add_to_storageclasses( $3, f_emptyId() );
		  v_extendoccur( $3, ITStorageClass() ); }
;
